#For git snapshots, set to 0 to use release instead:
%global usesnapshot 0
%if 0%{?usesnapshot}
%global         commit0 58eec8df1ee56a0ece2b8630564539a61152ff49 
%global         shortcommit0 %(c=%{commit0}; echo ${c:0:7})
%global         gitdate 20220330
%endif

Name:           strawberry-qt6
Summary:        A music player and music collection organizer
License:        GPL-3.0+
%if 0%{?usesnapshot}
Version:        1.0.4
Release:        0.1.%{gitdate}git%{shortcommit0}%{?dist}
URL:            https://www.strawberrymusicplayer.org/
Source:         https://github.com/strawberrymusicplayer/strawberry/archive/%{commit0}/%{name}-%{version}-%{shortcommit0}.tar.gz 
%else
Version:        1.0.22
Release:        1%{?dist}
URL:            https://www.strawberrymusicplayer.org/
Source:         https://github.com/strawberrymusicplayer/strawberry/archive/refs/tags/%{version}.tar.gz#/strawberry-%{version}.tar.gz
%endif

BuildRequires:  boost-devel
BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  gcc-c++
BuildRequires:  gettext
BuildRequires:  libappstream-glib
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(gio-unix-2.0)
BuildRequires:  pkgconfig(gthread-2.0)
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(gnutls)
BuildRequires:  pkgconfig(alsa)
BuildRequires:  pkgconfig(protobuf)
BuildRequires:  pkgconfig(sqlite3) >= 3.9
BuildRequires:  pkgconfig(taglib)
BuildRequires:  pkgconfig(fftw3)
BuildRequires:  cmake(Qt6Core)
BuildRequires:  cmake(Qt6Gui)
BuildRequires:  cmake(Qt6Widgets)
BuildRequires:  cmake(Qt6Concurrent)
BuildRequires:  cmake(Qt6Network)
BuildRequires:  cmake(Qt6Sql)
BuildRequires:  cmake(Qt6DBus)
BuildRequires:  cmake(Qt6Test)
#BuildRequires:  cmake(Qt6X11Extras)
BuildRequires:  pkgconfig(gstreamer-1.0)
BuildRequires:  pkgconfig(gstreamer-app-1.0)
BuildRequires:  pkgconfig(gstreamer-audio-1.0)
BuildRequires:  pkgconfig(gstreamer-base-1.0)
BuildRequires:  pkgconfig(gstreamer-tag-1.0)
BuildRequires:  kdsingleapplication-qt6-devel
BuildRequires:  pkgconfig(libchromaprint)
BuildRequires:  pkgconfig(libpulse)
BuildRequires:  pkgconfig(libcdio)
BuildRequires:  pkgconfig(libgpod-1.0)
BuildRequires:  pkgconfig(libmtp)
BuildRequires:  pkgconfig(libnotify)
BuildRequires:  pkgconfig(libudf)
BuildRequires:  qt6-qttools-devel
BuildRequires:  qt6-linguist
%ifnarch s390 s390x
BuildRequires:  pkgconfig(libgpod-1.0)
%endif
Requires:       qt6-qtbase
Requires:       gstreamer1-plugins-good
Requires:       hicolor-icon-theme

Provides:       bundled(singleapplication)
Provides:       bundled(taglib) = 1.12-1
Provides:       bundled(utf8-cpp)

Conflicts: strawberry

%description
Strawberry is a music player and music collection organizer.
It is a fork of Clementine. The name is inspired by the band Strawbs.

Features:
  - Play and organize music
  - Supports WAV, FLAC, WavPack, DSF, DSDIFF, Ogg Vorbis, Speex, MPC, TrueAudio, AIFF, MP4, MP3 and ASF
  - Audio CD playback
  - Native desktop notifications
  - Playlists in multiple formats
  - Advanced audio output and device configuration for bit-perfect playback on Linux
  - Edit tags on music files
  - Fetch tags from MusicBrainz
  - Album cover art from Last.fm, Musicbrainz, Discogs and Deezer
  - Song lyrics from AudD
  - Support for multiple backends
  - Audio analyzer
  - Audio equalizer
  - Transfer music to iPod, MTP or mass-storage USB player
  - Scrobbler with support for Last.fm, Libre.fm and ListenBrainz
  - Streaming support for Subsonic

%prep

%if 0%{?usesnapshot}
%setup -qn strawberry-%{commit0}
%else
%setup -qn strawberry-%{version}
%endif

%build
# QT applications need to avoid local binding and copy relocations.  Forcing them to build with
# -fPIC solves that problem
export CXXFLAGS="-fPIC $RPM_OPT_FLAGS"
%{cmake} -DBUILD_WERROR:BOOL=OFF \
         -DUSE_SYSTEM_TAGLIB=OFF \
         -DBUILD_WITH_QT6=ON

%cmake_build

%install
%cmake_install

%check
desktop-file-validate %{buildroot}%{_datadir}/applications/org.strawberrymusicplayer.strawberry.desktop
appstream-util validate-relax --nonet %{buildroot}%{_datadir}/metainfo/org.strawberrymusicplayer.strawberry.appdata.xml

%files
%license COPYING
%doc README.md Changelog
%{_bindir}/strawberry
%{_bindir}/strawberry-tagreader
%{_metainfodir}/org.strawberrymusicplayer.strawberry.appdata.xml
%{_datadir}/applications/org.strawberrymusicplayer.strawberry.desktop
%{_datadir}/icons/hicolor/*/apps/strawberry.*
%{_mandir}/man1/strawberry.1.*
%{_mandir}/man1/strawberry-tagreader.1.*

%changelog
* Thu Dec 28 2023 Martin Gansser <martinkg@fedoraproject.org> - 1.0.22-1
- Update to 1.0.22

* Fri Nov 17 2023 Martin Gansser <martinkg@fedoraproject.org> - 1.0.21-1
- Update to 1.0.21

* Tue Oct 25 2022 Martin Gansser <martinkg@fedoraproject.org> - 1.0.10-1
- Update to 1.0.10

* Tue Aug 02 2022 Martin Gansser <martinkg@fedoraproject.org> - 1.0.7-1
- Update to 1.0.7

* Fri Jul 22 2022 Martin Gansser <martinkg@fedoraproject.org> - 1.0.6-1
- Update to 1.0.6

* Wed Mar 30 2022 Martin Gansser <martinkg@fedoraproject.org> - 1.0.2-1
- Initial qt6 build
